package xcape;
public class caller extends objetodojogo {
    //essa classe de um inimigo do jogo, o caller tem a habilidade de
    //impedir o caminho de passagem do jogador, detectando este assim que
    //entra em seus dominios, mesmo que o jogador esteja em andar diferente

    double move = 0.4, n = 0, pos;
    int m = 2;
    boolean persegue = false, corre = false;

    //construtor da classe
    caller(double x, double y) {
        super(x, y, "Imagem/sere.png", 4, 4);
        pos = x;
    }

    //metodo básico de locomoção da classe
    void locomo() {
        //dentro do if o move define a velocidade de movimento e o m define
        //a linha do Sprite, ele se locomove
        //entre a posição original até (original+200), fazendo esta zona de 200
        //pixels sua zona de vigia
        if ((this.x) < (pos)) {
            move = 0.4;
            m = 2;
        }
        if ((this.x) > ((pos)+200)) {
            move = -0.4;
            m = 1;
        }
        this.x += move;
        if (n < 3) {
            this.sprite.setCurrFrame(((int) (n)), m);
            n += 0.04;
        } else {
            n = 0;
            this.sprite.setCurrFrame(((int) (n)), m);
        }
    }

    void basic(double ladrox, boolean escond, raio thunder){
        //O metodo basico da classe, recebe o objeto thunder para que possa
        //controla-lo e dados do player quanto a posição
        //esses 2 ifs garantem que o caller somente detectará  jogador se ele
        //estiver de frente para ele, ou seja, não detecta o jogador pelas costas.
        //Ele possui grande alcance de visão
        if (move < 0) {
            persegue = ((300 > (this.x - ladrox)) && (this.x - ladrox) > 0);
        }
        if (move > 0) {
            persegue = ((300 > (ladrox - this.x)) && (ladrox - this.x) > 0);
        }

        //o if abaixo torna a reação(corre) ativa e falsifica caso o jogador
        //fique invisível, tambem reposiciona o thunder
        if (persegue && escond == false) {
            corre = true;
        } else if (escond == true) {
            corre = false;
            thunder.x = -1000;
            thunder.y = -1000;
        }

        //o if faz uso do metodo taca da classe thunder e seta o sprite para
        //direção correta, o else if faz o mesmo porem para a outra direção
        //por fim o else faz a movimentação padrão usando o metodo acima
        if (corre && ladrox > this.x) {
            this.sprite.setCurrFrame(0, 2);
            thunder.taca(ladrox);
        } else if (corre && ladrox < this.x) {
            this.sprite.setCurrFrame(0, 1);
            thunder.taca(ladrox);
        } else {
            this.locomo();
        }
    }

    //esse metodo é usado para tirar vidas do jogador em caso de contato
    boolean over(objetodojogo obj)
    {
        if (this.sprite.collided(obj.sprite))
            return true;
        else
            return false;
    }

}
