package xcape;
import JPlay.Sound;

public class garras extends objetodojogo {
    //essa classe é manipulada pela classe lobo, idea da garre é ser um
    //atrazador, visto em conta que ela não pode ser desviada e segue o jogador
    //ate sumir

    int m = 0;

    //contrutor da classe
    garras(double x, double y) {
        super(x, y, "Imagem/garras.png", 3, 1);
    }

    //metodo padrão da classe, recebe constantemente os dados do jogador
    //fazendo assim estar sempre atualizada para persegui-lo
    void taca(double ladrox, double ladroy, lobo wolf) {
        //esse if coloca a garra na posição de lançamento do lobo
        if ((this.x == -1000) && this.y == -1000){
            new Sound("Sound/sword.wav").play();
            this.x = wolf.x;
            this.y = wolf.y+20;
        }

        //esses if, if else e else controlam o frame do sprite exibido
        // e o movimento em x
        if (this.x < ladrox) {
            this.sprite.setCurrFrame(0, 0);
            this.x++;
        } else if (this.x > ladrox) {
            this.sprite.setCurrFrame(2, 0);
            this.x--;
        } else {
            this.sprite.setCurrFrame(1, 0);
        }

        //esses if e if else controlam o movimento em y da garra
        if (this.y+20 < ladroy) {
            this.y++;
        } else if (this.y+20 > ladroy) {
            this.y--;
        }

        //esse if controla o tempo que a garra fica perseguindo o jogador até
        //desaparecer e voltar a posição padrão. liberando o lbo para lançar
        //outro ataque caso o jogador esteja em seus domínios
        if (m<1000)
        {
            m++;
        }else
        {
            this.x = -1000;
            this.y = -1000;
            m = 0;
            wolf.taca = false;
        }

    }

    //metodo de tirar vidas do jogador
    boolean over(objetodojogo obj) {
        if (this.sprite.collided(obj.sprite)) {
            return true;
        } else {
            return false;
        }
    }
}
