package xcape;
import JPlay.Sound;
public class ninjae extends objetodojogo {
    //essa classe é o ninja que controla fogo, ele tem percepção alta
    //e demora um certo tempo para terminar de usar a magia, porem se
    //conseguir usá-la o jogador somente poderá fugir de uma forma, mudando
    //de andar, pois sua explosão cobre o andar até o teto e ele lança
    //centralizando o meio da explosão com o jogador fazendo impossivel escapar
    //horizontamente
    double move = 0.4, n = 0, pos;
    int m = 2;
    boolean persegue = false, corre = false;

    //metodo contrutor da classe
    ninjae(double x, double y) {
        super(x, y, "Imagem/ninjae.png", 3, 6);
        pos = x;
    }

    //metodo de locomoção padrão da classe
    void locomo() {
        //dentro do if o move define a velocidade de movimento e o m define
        //a linha do Sprite, ele se locomove
        //entre a posição original até (original+200), fazendo esta zona de 200
        //pixels sua zona de vigia
        if ((this.x) < (pos)) {
            move = 0.4;
            m = 2;
        }
        if ((this.x) > ((pos)+200)) {
            move = -0.4;
            m = 1;
        }
        this.x += move;
        if (n < 3) {
            this.sprite.setCurrFrame(((int) (n)), m);
            n += 0.04;
        } else {
            n = 0;
            this.sprite.setCurrFrame(((int) (n)), m);
        }
    }

    //metodo de reação basica da classe, recebe os dados de posição do jogador
    //e considera caso ele esteja invisivel, impossivel mirá-lo. Tambem recebe
    //os objetos alvofogo e fogo para manipulá-los
    void basic(double ladrox, boolean escond, double ladroy, fogo fire, alvofogo alvo) {
        //o booleano persegue é validado quando o jogadro se aproxima, indiferencilamente
        //pela frente ou por traz, tambem detectando o jogador no teto
        //quando validade o ninjae entra em modo de perseguição(corre)
        persegue = (200 > Math.abs(this.x-ladrox) && (ladroy == this.y || (ladroy > this.y-140 && ladroy<this.y) ));
        if (persegue && escond == false) {
            corre = true;
        } else if (escond == true || ladroy != this.y) {
            corre = false;
        }

        //esses if e if else manipulam as classes alvofogo incialmente para
        //apararecer e fazer sua temporização e apos ser usada a magia de fogo
        //no jogador, tambem configura a posição de frame do Sprite
        //o else final faz executar o metodo de movimento padrão
        if (corre && ladrox > this.x) {
            this.sprite.setCurrFrame(0, 2);
            if (alvo.visivel == false)
            {
            alvo.x = x;
            alvo.y = y;
            alvo.visivel = true;
            }
            if (alvo.taca)
            {
            new Sound("Sound/explo.wav").play();
            fire.x = ladrox-133;
            fire.y = this.y-133;
            fire.visivel = true;
            alvo.taca = false;
            }
        } else if (corre && ladrox < this.x) {
            this.sprite.setCurrFrame(0, 1);
             if (alvo.visivel == false)
            {
            alvo.x = x;
            alvo.y = y;
            alvo.visivel = true;
            }
             if (alvo.taca)
            {
            new Sound("Sound/explo.wav").play();
            fire.x = ladrox-133;
            fire.y = this.y-133;
            fire.visivel = true;
            alvo.taca = false;
            }
        } else {
            this.locomo();
            alvo.visivel = false;
            alvo.i = 0;
        }
    }

    //metodo de tirar vidas do jogador
    boolean over(objetodojogo obj)
    {
        if (this.sprite.collided(obj.sprite))
            return true;
        else
            return false;
    }

}
