package xcape;

import JPlay.Sound;

public class ninjap extends objetodojogo {
    //o ninjap controla o objeto olho que muda de posição randomicamente
    //a cada intervalo de tempo. Enquanto o olho não detecta o jogador o
    //ninjap fica imóvel usando sua magia de controle, com total foco neste
    //impossibilitando de perceber a aproximação do jogador

    double n = 0, pos, alt;
    int m = 2, i = 0, s =0;
    boolean persegue = false, corre = false, vai = true;

    //o metodo contrutor da classe
    ninjap(double x, double y) {
        super(x, y, "Imagem/ninjap.png", 3, 6);
        pos = x;
        alt = y;
    }

    //o metodo que controla o olho, o inteiro i é usando para controlar
    //o tempo antes de mudar a posição do olho
    void controla(olho bola) {
        if (i < 400) {
            i++;
        } else {
            i = 0;
            bola.moveolho();
        }
    }

    //esse é o metodo de atitude padrão da classe, ela recebe a posição do jogador
    //e o booleano escond, caso invisivel a perseguição termina ou caso o jogador
    //mude para o teto ou chão, tambem a posição do olho
    void basic(double ladrox, boolean escond, double ladroy, double olhox, double olhoy, boolean teto) {
        //esse booleando torna-se verdadeiro com ajuda do olho que o posiciona
        //com as cordanadas corretas fazendo iniciar o modo de perseguição(corre)
        persegue = (100 > Math.abs(olhox - ladrox) && 100 > Math.abs(olhoy - ladroy));
        if (persegue && escond == false) {
            corre = true;
            //esse if define que se o olho detectou o alvo, o jogador, o ninjap
            //se teleporta para a posição do olho e persegue-o
            if (vai) {
                if (s==0)
                {
                    s++;
                    new Sound("Sound/teleport.wav").play();
                }
                this.x = olhox;
                this.y = ladroy;
                vai = false;
            }
        } else if (escond == true || ladroy != this.y) {
            corre = false;
            vai = true;
        }

        //esses if e if else configuram a perseguição, definindo velocidade
        //e mudança de frame do Sprite
        //o else final faz o ninjap voltar a sua posição inicial e voltar
        //a continuar com sua magia de controle do olho
        if (teto && corre && ladrox > this.x) {
            this.x += 0.8;
            m = 4;
            if (n < 3) {
                this.sprite.setCurrFrame(((int) (n)), m);
                n += 0.08;
            } else {
                n = 0;
                this.sprite.setCurrFrame(((int) (n)), m);
            }
        } else if (teto && corre && ladrox < this.x) {
            this.x -= 0.8;
            m = 5;
            if (n < 3) {
                this.sprite.setCurrFrame(((int) (n)), m);
                n += 0.08;
            } else {
                n = 0;
                this.sprite.setCurrFrame(((int) (n)), m);
            }
        } else if (corre && ladrox > this.x) {
            this.x += 0.8;
            m = 2;
            if (n < 3) {
                this.sprite.setCurrFrame(((int) (n)), m);
                n += 0.08;
            } else {
                n = 0;
                this.sprite.setCurrFrame(((int) (n)), m);
            }
        } else if (corre && ladrox < this.x) {
            this.x -= 0.8;
            m = 1;
            if (n < 3) {
                this.sprite.setCurrFrame(((int) (n)), m);
                n += 0.08;
            } else {
                n = 0;
                this.sprite.setCurrFrame(((int) (n)), m);
            }
        } else {
            if (s==1)
            {
                s=0;
                new Sound("Sound/teleport.wav").play();
            }
            this.x = pos;
            this.y = alt;
            m = 0;
            if (n < 3) {
                this.sprite.setCurrFrame(((int) (n)), m);
                n += 0.08;
            } else {
                n = 0;
                this.sprite.setCurrFrame(((int) (n)), m);
            }
        }
    }

    //metodo de tirar vidas do jogador
    boolean over(objetodojogo obj) {
        if (this.sprite.collided(obj.sprite)) {
            return true;
        } else {
            return false;
        }
    }
}
