package xcape;

import JPlay.*;
import java.awt.Color;
import java.awt.Font;
import java.io.FileNotFoundException;
import java.io.IOException;

public class telatutorial {
    //Essa classe tem como objetivo ser uma tela de introdução aos controles
    //e a missão do jogo

    public static void telatutorial(Window janela) throws FileNotFoundException, IOException {
        Window janel = janela;
        GameImage bac = new GameImage("Imagem/scroll.jpg");
        Keyboard teclad = janel.getKeyboard();
        boolean exec = true;
        int i=0;
        teclad.addKey(Keyboard.ENTER_KEY, Keyboard.DETECT_INITIAL_PRESS_ONLY);
        //Elementos visuais
        Sprite tecla = new Sprite("Imagem/teca.png");
        Sprite tecls = new Sprite("Imagem/tecs.png");
        Sprite spaces = new Sprite("Imagem/spaces.png");
        Sprite arrow = new Sprite("Imagem/arrow.png");
        pergaminho perg = new pergaminho(0,0,0);
        //Configuração de elementos visuais
        arrow.setPosition(320, 150);
        tecla.setPosition(170, 150);
        tecls.setPosition(170, 250);
        spaces.setPosition(170, 350);
        perg.sprite.setPosition(418, 225);
        //Os muitos elementos visuais acima são para ilustração do tutorial
        while (exec) {
            janel.clear();
            bac.draw();
            //O switch comanda os 3 modos de tela, que são introdução as setas no
            //o case 0, introdução e teclas no case 1 e introdução a missão
            //do jogono case 3.Por fim o case 4 que vai para a classe xcape
            switch (i)
            {
                case 0:
                    arrow.draw();
                    janel.drawText("Use as setas da direita e esquerda para mover o personagem.", 140, 330, Color.BLACK, new Font("Arial",Font.TRUETYPE_FONT, 20));
                    janel.drawText("Use as setas derecionais para cima ou para baixo para subir ou", 140, 380, Color.BLACK, new Font("Arial",Font.TRUETYPE_FONT, 20));
                    janel.drawText("descer de andar, respectivamente.", 140, 410, Color.BLACK, new Font("Arial",Font.TRUETYPE_FONT, 20));
                    break;
                case 1:
                    tecla.draw();
                    tecls.draw();
                    spaces.draw();
                    janel.drawText("- Para ir para o teto ou voltar para o chao.", 230, 180, Color.BLACK, new Font("Arial",Font.TRUETYPE_FONT, 20));
                    janel.drawText("- Pressione para aumentar a velocidade de correr.", 230, 280, Color.BLACK, new Font("Arial",Font.TRUETYPE_FONT, 20));
                    janel.drawText("- Aperte para ficar invisível.", 310, 380, Color.BLACK, new Font("Arial",Font.TRUETYPE_FONT, 20));
                    break;
                case 2:
                    perg.sprite.draw();
                    janel.drawText("Você comandará neste jogo um ninja disfarçado que tem como", 140, 200, Color.BLACK, new Font("Arial",Font.TRUETYPE_FONT, 20));
                    janel.drawText("objetivo coletar 8 pergaminhos(", 140, 240, Color.BLACK, new Font("Arial",Font.TRUETYPE_FONT, 20));
                    janel.drawText(") deste local fortemente protegido.", 440, 240, Color.BLACK, new Font("Arial",Font.TRUETYPE_FONT, 20));
                    janel.drawText("Não há problemas em algum guarda te notar pois você está com um", 140, 280, Color.BLACK, new Font("Arial",Font.TRUETYPE_FONT, 20));
                    janel.drawText("disfarce e não poderão saber que esteve ali. Porem não poderá", 140, 320, Color.BLACK, new Font("Arial",Font.TRUETYPE_FONT, 20));
                    janel.drawText("eliminar nenhum inimigo, pois estes te indentificariam em caso", 140, 360, Color.BLACK, new Font("Arial",Font.TRUETYPE_FONT, 20));
                    janel.drawText("de contato fisico. Fuja de todos inimigos e complete sua missão!", 140, 400, Color.BLACK, new Font("Arial",Font.TRUETYPE_FONT, 20));
                    break;
                case 3:
                    janel.dispose();
                    xcape.xcape();
            }
            //A tecla enter controla a exibição do switch somando o valor ao int
            janel.drawText("Enter para prosseguir!", 250, 500, Color.red, new Font("Arial",Font.TRUETYPE_FONT, 35));
            janel.display();
            if (teclad.keyDown(Keyboard.ENTER_KEY))
            {
                //toca o som e soma 1 ao inteiro de controle i
                new Sound("Sound/guitar.wav").play();
                i++;
            }
            }
    }
}
