package xcape;
import JPlay.Sound;
public class terra extends objetodojogo {
    //essa classe é controlada pela warrior, trata-se de um pilar de terra
    //que varre uma direção ate ser dicipado por um inimigo

    boolean subida= false, destroi = false, direct;

    //metodo construtor
    terra(double x, double y) {
        super(x, y, "Imagem/terra.png", 4, 1);
    }

    //metodo principal da classe, recebe os dados de direção e posição do warrior
    void taca(double x, boolean direita)
    {
        //posiciona o pilar abaixo do chao na direção do warrior
        if (((this.x == -1000) && this.y==-1000) && (!destroi))
        {
            new Sound("Sound/wind.wav").play();
            this.x = x;
            this.y = 600;
            direct = direita;
        }
        //faz o pilar se erguer até o teto
        if ((this.y>10) && (!destroi))
        {
            this.y-=8;
        }
        else
        {
            subida = true;
        }
        //faz o pilar se locomover para a direção que o warrior está voltado
        if ((subida) && (!destroi))
        {
            if (direct)
            {
                this.x+=2;
            }else{
                this.x-=2;
            }
      }
    }

    //metodo que destroi o pilar, sendo ativado somente por inimigos
    boolean cancela(objetodojogo obj)
    {
        if (this.sprite.collided(obj.sprite))
        {
           subida = false;
           destroi = true;
           return true;
        }
        destroi = false;
        return false;
    }

    //metodo de tirar vida do jogador
    boolean over(objetodojogo obj) {
        if (this.sprite.collided(obj.sprite)) {
            return true;
        } else {
            return false;
        }
    }

}
