package xcape;

import JPlay.*;
import java.awt.event.KeyEvent;
import java.io.FileNotFoundException;
import java.io.IOException;

public class xcape {

    public static void xcape() throws FileNotFoundException, IOException {
        camera camera = new camera(290, 0, 800, 600);
        // Cria a camera do jogo
        Keyboard teclado = camera.getKeyBoard();

        //Abaixo objetos usados para efeitos de fumaça e sumiço
        objetodojogo fumaca = new objetodojogo(0, 0, "Imagem/smoke.png", 5, 1);
        objetodojogo sumir = new objetodojogo(0, 0, "Imagem/fu.png", 4, 1);
        fumaca.sprite.setCurrFrame(4, 0);
        sumir.sprite.setCurrFrame(3, 0);

        objetodojogo fundo = new objetodojogo(0, 0, "Imagem/fundoreal.jpg");
        // Cria um objeto da classe jogador
        jogador player = new jogador(2000, 543);

        // Cria todos os inimigos do jogo, cada um com sua respectiva classe sendo 2 de cada
        policia popo = new policia(200, 543);
        policia popo1 = new policia(3400, 543);
        rapid sped = new rapid(1400, 353);
        rapid sped1 = new rapid(2600, 163);
        ninjae nin = new ninjae(400, 163);
        ninjae nin1 = new ninjae(2400, 353);
        ninjap nem = new ninjap(1800, 163);
        ninjap nem1 = new ninjap(3800, 353);
        warrior doton = new warrior(800, 543);
        warrior doton1 = new warrior(2000, 353);
        caller sere = new caller(800, 353);
        caller sere1 = new caller(3000, 353);
        lobo wolf = new lobo(1400, 503);
        lobo wolf1 = new lobo(3400, 123);

        //Cria os objetos usados para efeitos dos ataques dos inimigos
        garras claw = new garras(-1000, -1000);
        raio thunder = new raio(-1000, -1000);
        fogo fire = new fogo(-1000, -1000);
        alvofogo alvo = new alvofogo(-1000, -1000);
        fogo fire1 = new fogo(-1000, -1000);
        alvofogo alvo1 = new alvofogo(-1000, -1000);
        terra pilar = new terra(-1000, -1000);
        olho bola = new olho(-1000, -1000);
        olho bola1 = new olho(-1000, -1000);

        // cria os pergaminhos, os objetivos do jogo
        pergaminho scroll0 = new pergaminho(100, 563, 0);
        pergaminho scroll1 = new pergaminho(600, 373, 1);
        pergaminho scroll2 = new pergaminho(800, 183, 2);
        pergaminho scroll3 = new pergaminho(1500, 373, 3);
        pergaminho scroll4 = new pergaminho(2500, 373, 4);
        pergaminho scroll5 = new pergaminho(3300, 373, 5);
        pergaminho scroll6 = new pergaminho(3500, 183, 6);
        pergaminho scroll7 = new pergaminho(3500, 563, 7);

        // Adiciona as teclas A e S e as configura, tambem configura as teclas
        //para cima, para baixo e espaço
        teclado.addKey(KeyEvent.VK_A, Keyboard.DETECT_INITIAL_PRESS_ONLY);
        teclado.addKey(KeyEvent.VK_S, Keyboard.DETECT_EVERY_PRESS);
        teclado.setBehavior(Keyboard.UP_KEY, Keyboard.DETECT_INITIAL_PRESS_ONLY);
        teclado.setBehavior(Keyboard.DOWN_KEY, Keyboard.DETECT_INITIAL_PRESS_ONLY);
        teclado.setBehavior(Keyboard.SPACE_KEY, Keyboard.DETECT_INITIAL_PRESS_ONLY);

        /* Booleanos para controle abaixo
         * Executando controla o loop do jogo
         * sumi controla a execução do sumiço
         * fumac controla a fumaça que o jogador deixa quando teleporta
         * escond define se o jogador está escondido
         * teto define se o jogador está no teto
         * preto controla o piscar da tela
         * gover controla procedimentos de quando o jogador perde vida
         * destroipilar controla a destruição do objeto pilar, um efeito criado por um inimigo
         * finalizando controla a tela de Game Over
         * venceu coontrola a tela do You Win
         */
        boolean executando = true,
                tele = true, sumi = false, fumac = false, escond = false,
                teto = false, preto = false, gover = false,
                destroipilar = false, finalizando = false, venceu = false;
        //i,j,k,p,h são variveis de controle de tempo
        double velocidade = 1, i = 0, j = 0, k = 0, p = 0, h = 0;
        // aciona ints para numeração e controle
        int sumico = 0, pisca = 0, pergaminhos = 0, espera = 0, vidas = 3;
        //aciona procedimentos padrões da camera
        camera.setar();
        camera.carregaponto();
        while (executando) {
            //limpa o buffer da camera
            camera.Clear();
            if (venceu) {
                // se o controle venceu der true entra neste if
                // o if abaixo numerado, controla o tempo que a tela you win vai ficar aparecendo
                if (espera < 300) {
                    fundo.x = 3200;
                    fundo.y = 0;
                    fundo.sprite.loadImage("Imagem/win.jpg");
                    camera.Draw(fundo);
                    camera.Display();
                    espera++;
                } else {
                    //depois do tempo passar a loop da false e o jogo volta pra tela incial
                    espera = 0;
                    executando = false;
                }
            } else {
                if (finalizando) {
                    // se o controle finalizando der true entra neste if
                    // o if abaixo numerado, controla o tempo que a tela game over vai ficar aparecendo
                    if (espera < 300) {
                        fundo.x = player.x - 400;
                        fundo.y = 0;
                        fundo.sprite.loadImage("Imagem/over.jpg");
                        camera.Draw(fundo);
                        camera.Display();
                        espera++;
                    } else {
                        //depois do tempo passar a loop da false e o jogo volta pra tela incial
                        espera = 0;
                        executando = false;
                    }
                } else {
                    if (preto) {
                        // controla o tempo de piscar a tela com preto
                        if (pisca < 10) {
                            fundo.sprite.loadImage("Imagem/preta.jpg");
                            camera.Draw(fundo);
                            camera.Display();
                            pisca++;
                        } else {
                            preto = false;
                            pisca = 0;
                        }
                    } else {
                        // a camera carrega pelo metodo draw todos os objetos do jogo:>>
                        //>fundo
                        fundo.sprite.loadImage("Imagem/fundoreal.jpg");
                        camera.Draw(fundo);
                        //>textos de exibição
                        camera.Drawtext();
                        //>pergaminhos
                        camera.Draw(scroll0);
                        camera.Draw(scroll1);
                        camera.Draw(scroll2);
                        camera.Draw(scroll3);
                        camera.Draw(scroll4);
                        camera.Draw(scroll5);
                        camera.Draw(scroll6);
                        camera.Draw(scroll7);

                        //>jogador
                        camera.Draw(player);
                        //>inimigos
                        camera.Draw(nem);
                        camera.Draw(wolf);
                        camera.Draw(popo);
                        camera.Draw(sped);
                        camera.Draw(sere);
                        camera.Draw(nin);
                        camera.Draw(doton);
                        camera.Draw(nem1);
                        camera.Draw(wolf1);
                        camera.Draw(popo1);
                        camera.Draw(sped1);
                        camera.Draw(sere1);
                        camera.Draw(nin1);
                        camera.Draw(doton1);
                        //>efeitos
                        camera.Draw(sumir);
                        camera.Draw(fire);
                        camera.Draw(fire1);
                        camera.Draw(alvo);
                        camera.Draw(alvo1);
                        camera.Draw(pilar);
                        camera.Draw(claw);
                        camera.Draw(thunder);
                        camera.Draw(bola);
                        camera.Draw(bola1);
                        camera.Draw(fumaca);
                        //carrega objetos que ficam no topo da tela
                        camera.fixos(vidas, pergaminhos);
                        camera.Display();
                        //delay para controle de velocidade
                        camera.Delay();
                        //coloca a camera para seguir o jogador
                        camera.seguir(player);
                        //ativa as habilidades padrão do jogador
                        player.padrao(teto);
                        //ativa as funcionalides padrão dos inimigos
                        popo.basic(player.x, escond, player.y);
                        doton.basic(player.x, escond, player.y, pilar);
                        sped.basic(player.x, escond, player.y);
                        sere.basic(player.x, escond, thunder);
                        wolf.basic(player.x, escond, player.y, claw);
                        nin.basic(player.x, escond, player.y, fire, alvo);
                        nem.basic(player.x, escond, player.y, bola.x, bola.y, teto);
                        popo1.basic(player.x, escond, player.y);
                        doton1.basic(player.x, escond, player.y, pilar);
                        sped1.basic(player.x, escond, player.y);
                        sere1.basic(player.x, escond, thunder);
                        wolf1.basic(player.x, escond, player.y, claw);
                        nin1.basic(player.x, escond, player.y, fire1, alvo1);
                        nem1.basic(player.x, escond, player.y, bola1.x, bola1.y, teto);
                        //faz o ninja da estrela azul assumir o controle do olho
                        nem.controla(bola);
                        nem1.controla(bola1);
                        //ativa os efeitos especiais
                        fire.normal();
                        alvo.normal();
                        fire1.normal();
                        alvo1.normal();
                        //usa o metodo da classe pergaminhos para gerenciar o valor de pergaminhos
                        pergaminhos += scroll0.pegou(player);
                        pergaminhos += scroll1.pegou(player);
                        pergaminhos += scroll2.pegou(player);
                        pergaminhos += scroll3.pegou(player);
                        pergaminhos += scroll4.pegou(player);
                        pergaminhos += scroll5.pegou(player);
                        pergaminhos += scroll6.pegou(player);
                        pergaminhos += scroll7.pegou(player);

                        //os metodos booleeanos abaixo controlam a habilidade
                        //dos inimigos de cancelar o pilar de terra lançado pelo inimigo "warrior"
                        if (pilar.cancela(nin)) {
                            doton.corre = false;
                            doton1.corre = false;
                            doton.taca = false;
                            doton1.taca = false;
                            destroipilar = true;
                        }
                        if (pilar.cancela(nem)) {
                            doton.corre = false;
                            doton1.corre = false;
                            doton.taca = false;
                            doton1.taca = false;
                            destroipilar = true;
                        }
                        if (pilar.cancela(sped)) {
                            doton.corre = false;
                            doton1.corre = false;
                            doton.taca = false;
                            doton1.taca = false;
                            destroipilar = true;
                        }
                        if (pilar.cancela(popo)) {
                            doton.corre = false;
                            doton1.corre = false;
                            doton.taca = false;
                            doton1.taca = false;
                            destroipilar = true;
                        }
                        if (pilar.cancela(sere)) {
                            doton.corre = false;
                            doton1.corre = false;
                            doton.taca = false;
                            doton1.taca = false;
                            destroipilar = true;
                        }
                        if (pilar.cancela(wolf)) {
                            doton.corre = false;
                            doton1.corre = false;
                            destroipilar = true;
                        }
                        if (pilar.cancela(nin1)) {
                            doton.corre = false;
                            doton1.corre = false;
                            destroipilar = true;
                        }
                        if (pilar.cancela(nem1)) {
                            doton.corre = false;
                            doton1.corre = false;
                            doton.taca = false;
                            doton1.taca = false;
                            destroipilar = true;
                        }
                        if (pilar.cancela(sped1)) {
                            doton.corre = false;
                            doton1.corre = false;
                            doton.taca = false;
                            doton1.taca = false;
                            destroipilar = true;
                        }
                        if (pilar.cancela(popo1)) {
                            doton.corre = false;
                            doton1.corre = false;
                            doton.taca = false;
                            doton1.taca = false;
                            destroipilar = true;
                        }
                        if (pilar.cancela(sere1)) {
                            doton.corre = false;
                            doton1.corre = false;
                            doton.taca = false;
                            doton1.taca = false;
                            destroipilar = true;
                        }
                        if (pilar.cancela(wolf1)) {
                            doton.corre = false;
                            doton1.corre = false;
                            doton.taca = false;
                            doton1.taca = false;
                            destroipilar = true;
                        }

                        //o evento abaixo faz o pilar ser destruido aos poucos e
                        //depois voltar a sua posição original
                        if (destroipilar) {
                            if (p < 3) {
                                pilar.sprite.setCurrFrame(((int) (p)), 0);
                                p += 0.04;
                            } else {
                                pilar.x = -1000;
                                pilar.y = -1000;
                                p = 0;
                                pilar.sprite.setCurrFrame(0, 0);
                                destroipilar = false;
                            }
                        }

                        //a condicional faz o jogador usar a habilidade de
                        //invisibilidade se apertar o espaço
                        if (teclado.keyDown(Keyboard.SPACE_KEY)) {
                            if (escond) {
                                escond = false;
                            } else {
                                //posiciona o efeito especial de invisibilidade
                                new Sound("Sound/teleport.wav").play();
                                sumir.x = player.x;
                                sumir.y = player.y + 9;
                                escond = true;
                                sumi = true;
                            }
                            sumico = 0;
                        }

                        //a condicional abaixo faz o jogador depois de um tempo
                        // voltar a forma visivel
                        if ((j < 4) && (sumi)) {
                            sumir.sprite.setCurrFrame(((int) (j)), 0);
                            j += 0.1;
                        } else {
                            j = 0;
                            sumi = false;
                        }

                        //a condicional abaixo gerencia o efeito da fumaça deixada
                        //quando jogador muda de andar ou vai para o teto
                        if ((i < 5) && (fumac)) {
                            fumaca.sprite.setCurrFrame(((int) (i)), 0);
                            i += 0.1;
                        } else {
                            //coloca o booleano tele true possibilitando usar a
                            //habilidade de teleport novamente
                            // com esse booleano e a temporização da fumaça eh
                            //possivel garantir que o jogador tenha em certo
                            //tempo de Delay para reusar suas habilidade de teleporte
                            tele = true;
                            i = 0;
                            fumac = false;
                        }

                        //abaixo uma condicional geral que impede do jogador se mover
                        //e usar habilidades se estiver invisivel
                        if ((escond) && (sumico < 200)) {
                            camera.Hide(player);
                            sumico++;
                        } else {

                            //abaixo os metodos dos inimigos de reduzir vidas do jogador
                            //caso eles o peguem e tambem os mesmos metodos para seus ataques especiais
                            if (popo.over(player)) {
                                vidas--;
                                gover = true;
                            }
                            if (sped.over(player)) {
                                vidas--;
                                gover = true;
                            }
                            if (nin.over(player)) {
                                vidas--;
                                gover = true;
                            }
                            if (nem.over(player)) {
                                vidas--;
                                gover = true;
                            }
                            if (wolf.over(player)) {
                                vidas--;
                                gover = true;
                            }
                            if (sere.over(player)) {
                                vidas--;
                                gover = true;
                            }
                            if (doton.over(player)) {
                                vidas--;
                                gover = true;
                            }

                            if (popo1.over(player)) {
                                vidas--;
                                gover = true;
                            }
                            if (sped1.over(player)) {
                                vidas--;
                                gover = true;
                            }
                            if (nin1.over(player)) {
                                vidas--;
                                gover = true;
                            }
                            if (nem1.over(player)) {
                                vidas--;
                                gover = true;
                            }
                            if (wolf1.over(player)) {
                                vidas--;
                                gover = true;
                            }
                            if (sere1.over(player)) {
                                vidas--;
                                gover = true;
                            }
                            if (doton1.over(player)) {
                                vidas--;
                                gover = true;
                            }

                            if (pilar.over(player)) {
                                vidas--;
                                gover = true;
                            }
                            if (claw.over(player)) {
                                vidas--;
                                gover = true;
                            }
                            if (thunder.over(player)) {
                                vidas--;
                                gover = true;
                            }

                            //Separei a explosão de fogo em um caso especial de
                            //morte para que pelo menos ela dure um certo tempo exibida
                            //mas no final ela gera o mesmo resultado de reduzir
                            //vidas dos demais efeitos
                            if (fire.over(player)) {
                                if (k < 20) {
                                    k++;
                                } else {
                                    vidas--;
                                    gover = true;
                                }
                            } else {
                                k = 0;
                            }
                            if (fire1.over(player)) {
                                if (h < 20) {
                                    h++;
                                } else {
                                    vidas--;
                                    gover = true;
                                }
                            } else {
                                h = 0;
                            }


                            sumico = 0;
                            escond = false;
                            camera.unHide(player);

                            //abaixo os botões UP e DOWN controlam a habilidade
                            //de subir e descer de andar
                            if ((teclado.keyDown(Keyboard.UP_KEY) && player.y > 210) && (tele)) {
                                //posiciona a fumaça no lacal que o jogador vai sair
                                fumaca.x = player.x;
                                fumaca.y = player.y;
                                new Sound("Sound/poof.wav").play();
                                //muda a posição do jogador
                                player.y -= 190;
                                //inicia a fumaça
                                fumac = true;
                                //ativa a piscar de tela
                                preto = true;
                                //falsifica o booleando tornando esse IF falso,
                                //assim impedindo de usar essa habilidade em um certo tempo
                                tele = false;
                            }
                            //o metodo para baixo é análogo ao de ir pra cima
                            if ((teclado.keyDown(Keyboard.DOWN_KEY) && player.y < 410) && (tele)) {
                                fumaca.x = player.x;
                                fumaca.y = player.y;
                                new Sound("Sound/poof.wav").play();
                                player.y += 190;
                                fumac = true;
                                preto = true;
                                tele = false;
                            }

                            //o if permite o uso da habilidade teleportar para o teto
                            //mais uma vez com o booleano de controle tele para
                            //evitar usos repetivos e garantir a jogabilidade
                            if ((teclado.keyDown(KeyEvent.VK_A)) && (tele)) {
                                //o booleano abaixo faz o controle, se ele estiver no chao, vai pro teto
                                if (teto == false) {
                                    //coloca a fumaça na posição atual do jogador
                                    fumaca.x = player.x;
                                    fumaca.y = player.y;
                                    new Sound("Sound/poof.wav").play();
                                    //teleporta ele
                                    player.y -= 175 - player.sprite.height;
                                    //controla os efeitos de fumaça e piscar de tela
                                    fumac = true;
                                    preto = true;
                                    //marca o booleano de controle como true, ele está no teto
                                    teto = true;
                                    //booleano de controle falsificado para evitar uso repetivo
                                    tele = false;
                                    //no caso else, se ele estiver no teto vai pro chão
                                } else {
                                    fumaca.x = player.x;
                                    fumaca.y = player.y;
                                    new Sound("Sound/poof.wav").play();
                                    player.y += 175 - player.sprite.height;
                                    fumac = true;
                                    preto = true;
                                    teto = false;
                                    tele = false;
                                }
                            }

                            //o if abaixo garante o jogador o dobro de velocidade padrão
                            //se precionar o butão S do teclado
                            if (teclado.keyDown(KeyEvent.VK_S)) {
                                velocidade = 2;
                            } else {
                                velocidade = 1;
                            }

                            //os ifs abaixo controlam o movimento do jogador nos andares
                            //limitado pelos limites da fase
                            if ((teclado.keyDown(Keyboard.LEFT_KEY)) && (player.x > 0)) {
                                player.moveesquerda(velocidade, teto);
                            } else if ((teclado.keyDown(Keyboard.RIGHT_KEY)) && (player.x < 3960)) {
                                player.movedireita(velocidade, teto);
                            }
                        }

                        //condicional de vitória, se o jogador pegar todos os pegaminhos
                        //e estiver na posição certa ele vencerá colocando o booleano venceu
                        //em verdade e caindo na condicional no começo do Loop
                        if ((pergaminhos == 8) && player.x > 3950 && player.y > 353) {
                            new Sound("Sound/appla.wav").play();
                            venceu = true;
                        }

                        //fecha o jogo se precionar o tecla esc e vai para tela inicial
                        if ((teclado.keyDown(Keyboard.ESCAPE_KEY))) {
                            new Sound("Sound/guitar.wav").play();
                            camera.Dispose();
                            game.game();
                        }

                        //controla todos os procedimentos que devem ser adotados
                        //caso o jogador morra, dentre eles colocar o jogador de
                        //cabeça pra cima no chão, desaparecer com efeitos e
                        //falsificar a perguição de inimigos, alem de fazer o
                        //jogador voltar ao local de entrada
                        if (gover) {
                            new Sound("Sound/thud.wav").play();
                            escond = true;
                            teto = false;
                            claw.m = 1000;
                            doton.taca = false;
                            doton1.taca = false;
                            pilar.x = -1000;
                            pilar.y = -1000;
                            gover = false;
                            player.x = 2000;
                            player.y = 543;
                        }

                        //a condicional controla o fim do jogo, se as vidas zerarem
                        //o booleano finalizando dá true e o loop fica concentrado no if
                        //situado no começo do loop
                        if (vidas < 0) {
                            camera.seguir(player);
                            new Sound("Sound/laugh.wav").play();
                            finalizando = true;
                        }

                    }
                }
            }
        }
        //usa o metodos de salvar score em memoria e em arquivo
        //depois fecha a janela e abre a tela inicial
        camera.atualizaponto();
        camera.salvaponto();
        camera.Dispose();
        game.game();
    }
}
