package xcape;
public class jogador extends objetodojogo {
    //Essa é a classe que o jogador do jogo irá controlar, ela possui
    //habilidades de elevar velocidade, teleportar entre andares ou para o teto
    //e ficar invisivel

    int m=0;
    double n = 0;
    boolean fui = true;

    //metodo construtor da classe
    jogador(double x, double y) {
        super(x, y, "Imagem/seph.png", 4, 8);
    }

    //metodo de movimentação para esquerda
    void moveesquerda(double velo, boolean teto) {
        fui = true;
        //os ifs abaixo controlam a exibição dos sprites
        if (teto)
            m = 5;
        else
            m = 1;
        if (n < 4) {
            this.sprite.setCurrFrame(((int) (n)), m);
            this.x -= velo;
            n += 0.08;
        } else {
            n = 0;
            this.sprite.setCurrFrame(((int) (n)), m);
            this.x -= velo;
        }
    }

    //metodo de movimentação para a direita
    void movedireita(double velo, boolean teto) {
        fui = false;
        //os ifs abaixo controlam a exibição dos sprites
        if (teto)
            m = 6;
        else
            m = 2;
        if (n < 4) {
            this.sprite.setCurrFrame(((int) (n)), m);
            this.x += velo;
            n += 0.08;
        } else {
            n = 0;
            this.sprite.setCurrFrame(((int) (n)), m);
            this.x += velo;
        }
    }

    //metodo que configura o sprite padrão, fazendo-o retornar ao sprite que mostra
    //a posição do personagem parado apontando para a direção ultimamente escolhida
    void padrao(boolean teto) {
        if (teto) {
            if (fui) {
                this.sprite.setCurrFrame(3, 5);
            } else {
                this.sprite.setCurrFrame(3, 6);
            }
        } else {
            if (fui) {
                this.sprite.setCurrFrame(0, 1);
            } else {
                this.sprite.setCurrFrame(0, 2);
            }

        }
    }
 }